//==========================================================================
//
//		tx37_misc.c
//
//		HAL misc board support code for the TX37 board
//
//==========================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
// at http://sources.redhat.com/ecos/ecos-license/
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
//========================================================================*/

#include <pkgconf/hal.h>
#include <pkgconf/system.h>
#include <redboot.h>
#include CYGBLD_HAL_PLATFORM_H

#include <cyg/infra/cyg_type.h>			// base types
#include <cyg/infra/cyg_trac.h>			// tracing macros
#include <cyg/infra/cyg_ass.h>			// assertion macros

#include <cyg/hal/hal_io.h>				// IO macros
#include <cyg/hal/hal_arch.h>			// Register state info
#include <cyg/hal/hal_diag.h>
#include <cyg/hal/hal_intr.h>			// Interrupt names
#include <cyg/hal/hal_cache.h>
#include <cyg/hal/hal_soc.h>		 // Hardware definitions
#include <cyg/hal/karo_tx37.h>			   // Platform specifics
//#include <cyg/io/mxc_i2c.h>
#include <cyg/infra/diag.h>				// diag_printf

// All the MM table layout is here:
#include <cyg/hal/hal_mm.h>

externC void* memset(void *, int, size_t);

volatile void *gpio_mcu1 = (volatile void *)GPIO1_BASE_ADDR;
volatile void *gpio_mcu2 = (volatile void *)GPIO2_BASE_ADDR;
volatile void *gpio_mcu3 = (volatile void *)GPIO3_BASE_ADDR;
volatile void *iomux = (volatile void *)IOMUXC_BASE_ADDR;

/* point to Data Direction Registers (DDIR) of all GPIO ports */
static volatile cyg_uint32 *const data_dir_reg_ptr_array[3] = {
	(cyg_uint32 *) ((cyg_uint32) GPIO1_BASE_ADDR + 4),
	(cyg_uint32 *) ((cyg_uint32) GPIO1_BASE_ADDR + 4),
	(cyg_uint32 *) ((cyg_uint32) GPIO1_BASE_ADDR + 4)
};

/* point to Data Registers (DR) of all GPIO ports */
static volatile unsigned int *const data_reg_ptr_array[3] = {
	(cyg_uint32 *) GPIO1_BASE_ADDR,
	(cyg_uint32 *) GPIO2_BASE_ADDR,
	(cyg_uint32 *) GPIO3_BASE_ADDR
};

/* point to Pad Status Registers (PSR) of all GPIO ports */
static volatile unsigned int *const pad_status_reg_ptr_array[3] = {
	(cyg_uint32 *) ((cyg_uint32) GPIO1_BASE_ADDR + 4 * 2),
	(cyg_uint32 *) ((cyg_uint32) GPIO2_BASE_ADDR + 4 * 2),
	(cyg_uint32 *) ((cyg_uint32) GPIO3_BASE_ADDR + 4 * 2)
};

/* point to IOMUX SW MUX Control Registers*/
static volatile unsigned int *const iomux_sw_mux_ctrl_reg_array[3] = {
	(cyg_uint32 *) ((cyg_uint32) IOMUXC_BASE_ADDR + 0x0008),	//the offset of sw_mux_ctrl_reg_array is 0x0004
	(cyg_uint32 *) ((cyg_uint32) IOMUXC_BASE_ADDR + 0x0230),	//the offset of sw_pad_ctrl_reg_array is 0x0328
	(cyg_uint32 *) ((cyg_uint32) IOMUXC_BASE_ADDR + 0x0508),	//the offset of daisy_sel_in_reg_array is 0x07AC
};

#if 1
#define UARO_URXD	0x00
#define UARO_UTXD	0x40
#define UARO_UCR1	0x80
#define UARO_UCR2	0x84
#define UARO_UCR3	0x88
#define UARO_UCR4	0x8c
#define UARO_UFCR	0x90
#define UARO_USR1	0x94
#define UARO_USR2	0x98
#define UARO_UESC	0x9c
#define UARO_UTIM	0xa0
#define UARO_UBIR	0xa4
#define UARO_UBMR	0xa8
#define UARO_UBRC	0xac
#define UARO_ONEMS	0xb0
#define UARO_UTS	0xb4

void plf_uart_init(void)
{
	unsigned long val;
	unsigned long UartRefFreq;

	// UART1
	//RXD
	writel(0x0, IOMUXC_BASE_ADDR + 0x15C);
	writel(0x4, IOMUXC_BASE_ADDR + 0x604);
	writel(0x1C5, IOMUXC_BASE_ADDR + 0x3BC);

	//TXD
	writel(0x0, IOMUXC_BASE_ADDR + 0x160);
	writel(0x1C5, IOMUXC_BASE_ADDR + 0x3C0);

	//RTS
	writel(0x0, IOMUXC_BASE_ADDR + 0x164);
	writel(0x4, IOMUXC_BASE_ADDR + 0x600);
	writel(0x1C4, IOMUXC_BASE_ADDR + 0x3C4);

	//CTS
	writel(0x0, IOMUXC_BASE_ADDR + 0x168);
	writel(0x1C4, IOMUXC_BASE_ADDR + 0x3C8);

	/* Wait for UART to finish transmitting */
	while (!(readl(UART1_BASE_ADDR + UARO_UTS) & 0x40));

	/* Disable UART */
	val = readl(UART1_BASE_ADDR + UARO_UCR1); 
	writel(val & 0xfffffffe, UART1_BASE_ADDR + UARO_UCR1); /* reset UARTEN */

	/* Set to default POR state */
	writel(0x00000000, UART1_BASE_ADDR + UARO_UCR1);
	writel(0x00000000, UART1_BASE_ADDR + UARO_UCR2);

	while (!(readl(UART1_BASE_ADDR + UARO_UCR2) & 1));		/* wait for SRST = 1 */

	writel(0x00000704, UART1_BASE_ADDR + UARO_UCR3);
	writel(0x00008000, UART1_BASE_ADDR + UARO_UCR4);
	writel(0x00000801, UART1_BASE_ADDR + UARO_UFCR);
	writel(0x0000002B, UART1_BASE_ADDR + UARO_UESC);
	writel(0x00000000, UART1_BASE_ADDR + UARO_UTIM);
	writel(0x00000000, UART1_BASE_ADDR + UARO_UBIR);
	writel(0x00000000, UART1_BASE_ADDR + UARO_UBMR);
	writel(0x00000000, UART1_BASE_ADDR + UARO_ONEMS);
	writel(0x00000000, UART1_BASE_ADDR + UARO_UTS);

	/* Configure FIFOs */
	writel((1 << 0) | (4 << 7) | (2 << 10), UART1_BASE_ADDR + UARO_UFCR);
	UartRefFreq = 66500000 / 2;

	/* Setup One MS timer */
	writel((UartRefFreq / 1000), UART1_BASE_ADDR + UARO_ONEMS);

	/* Set to 8N1 */
	val = readl(UART1_BASE_ADDR + UARO_UCR2); 
	val &= ~(1 << 8);
	val |= (1 << 5);
	val |= (1 << 14); /* Ignore RTS */
	val &= ~(1 << 6);
	writel(val, UART1_BASE_ADDR + UARO_UCR2); 

	/* Enable UART */
	val = readl(UART1_BASE_ADDR + UARO_UCR1); 
	writel(val | 1, UART1_BASE_ADDR + UARO_UCR1); 

	/* Enable FIFOs */
	val = readl(UART1_BASE_ADDR + UARO_UCR2); 
	val |= (1 << 0);
	val |= (1 << 1);
	val |= (1 << 2);
	writel(val, UART1_BASE_ADDR + UARO_UCR2); 

	/* Clear status flags */
	val = readl(UART1_BASE_ADDR + UARO_USR2); 
	val |= 0x9197;
	writel(val, UART1_BASE_ADDR + UARO_USR2); 

	/* Clear status flags */
	val = readl(UART1_BASE_ADDR + UARO_USR1); 
	val |= 0x9c30;
	writel(val, UART1_BASE_ADDR + UARO_USR1); 

	/* Set the numerator value minus one of the BRM ratio */
	writel((115200 / 100) - 1, UART1_BASE_ADDR + UARO_UBIR);

	/* Set the denominator value minus one of the BRM ratio	   */
	writel((UartRefFreq / 1600) - 1, UART1_BASE_ADDR + UARO_UBMR);

	writel('+', UART1_BASE_ADDR + UARO_UTXD);
}

void plf_send_char(unsigned char c)
{
	/* Wait for UART to finish transmitting */
	while (!(readl(UART1_BASE_ADDR + UARO_UTS) & 0x40));

	writel(c, UART1_BASE_ADDR + UARO_UTXD);
}

void plf_send_string(const char *spt)
{
	unsigned char achar;

	while ((achar = *(spt++)) != '\0') {
		plf_send_char(achar);
	}
}

void plf_printhex(unsigned long val)
{
	int i;

	for (i = 28; i >= 0; i -= 4) {
		int digit = (val >> i) & 0xf;
		plf_send_char(digit + ((digit < 10) ? '0' : ('A' - 10)));
	}
}

void plf_dumpmem(unsigned long addr, int len)
{
	int i;

	for (i = 0; i < len; i += 4) {
		unsigned long *wp = (unsigned long *)(addr + i);
		if (i % 16 == 0) {
			plf_send_char('\r');
			plf_send_char('\n');
			plf_printhex(addr + i);
			plf_send_char(' ');
		}
		plf_printhex(*wp);
		plf_send_char(' ');
	}
	if (i % 16 == 0) {
		plf_send_char('\r');
		plf_send_char('\n');
	}
}

void hal_mmu_check(void)
{
	unsigned long cr0, cr1;

	asm volatile ("mrc	p15, 0, %0, c1, c0, 0" : "=r"(cr0) /*:*/);
	asm volatile ("mrc	p15, 0, %0, c1, c0, 1" : "=r"(cr1) /*:*/);
	plf_printhex(cr0);
	plf_send_char(' ');
	plf_printhex(cr1);
	plf_send_char('\r');
	plf_send_char('\n');
}

#define DBG_FUNC() do {				\
	plf_send_string(__FUNCTION__);		\
	plf_send_char('\r');			\
	plf_send_char('\n');			\
	} while (0)
#endif

void hal_mmu_init(void)
{
	unsigned long ttb_base = RAM_BANK0_BASE + 0x4000;
	unsigned long i;
#ifdef DEBUG
	plf_uart_init();
	DBG_FUNC();
	hal_mmu_check();
#endif
	/*
	 * Set the TTB register
	 */
	asm volatile ("mcr	p15, 0, %0, c2, c0, 0" : : "r"(ttb_base) /*:*/);

	/*
	 * Set the Domain Access Control Register
	 */
	i = ARM_ACCESS_DACR_DEFAULT;
	asm volatile ("mcr	p15, 0, %0, c3, c0, 0" : : "r"(i) /*:*/);

	/*
	 * First clear all TT entries - ie Set them to Faulting
	 */
	memset((void *)ttb_base, 0, ARM_FIRST_LEVEL_PAGE_TABLE_SIZE);

	/*	     Physical Virtual   Size   Attributes						     Function */
	/*	     Base     Base      MB     cached?		buffered?	  access permissions		      */
	/*	     xxx00000 xxx00000										      */
	X_ARM_MMU_SECTION(0x000, 0x200,	0x200, ARM_UNCACHEABLE, ARM_UNBUFFERABLE, ARM_ACCESS_PERM_RW_RW); /* ROM */
	X_ARM_MMU_SECTION(0x100, 0x100,	0x001, ARM_UNCACHEABLE, ARM_UNBUFFERABLE, ARM_ACCESS_PERM_RW_RW); /* IRAM */
	X_ARM_MMU_SECTION(0x400, 0x000,	TX37_SDRAM_SIZE >> 20, ARM_CACHEABLE,	ARM_BUFFERABLE,	  ARM_ACCESS_PERM_RW_RW); /* SDRAM */
	X_ARM_MMU_SECTION(0x400, 0x400,	TX37_SDRAM_SIZE >> 20, ARM_CACHEABLE,	ARM_BUFFERABLE,	  ARM_ACCESS_PERM_RW_RW); /* SDRAM */
	X_ARM_MMU_SECTION(0x7ff, 0x7ff,	0x001, ARM_UNCACHEABLE, ARM_UNBUFFERABLE, ARM_ACCESS_PERM_RW_RW); /* NAND Flash buffer */
	X_ARM_MMU_SECTION(0x800, 0x800,	0x020, ARM_UNCACHEABLE, ARM_UNBUFFERABLE, ARM_ACCESS_PERM_RW_RW); /* IPUv3D */
	X_ARM_MMU_SECTION(0xB00, 0xB00,	0x400, ARM_UNCACHEABLE, ARM_UNBUFFERABLE, ARM_ACCESS_PERM_RW_RW); /* periperals */

#ifdef DEBUG
#if 1
	plf_printhex(ttb_base);
	plf_send_char('\r');
	plf_send_char('\n');
#endif
#if 0
	plf_dumpmem(ttb_base, ARM_FIRST_LEVEL_PAGE_TABLE_SIZE);
#endif
#if 1
	plf_dumpmem(0xc3fa8000, 0x1000);
#endif
#if 0
	plf_dumpmem(0xc3fa8000, 0x1000);
	plf_dumpmem(0xc3fa8000, 0x1000);
	plf_dumpmem(0xc3fa8000, 0x1000);
#endif
#endif
}

//
// Platform specific initialization
//

void plf_hardware_init(void)
{
	unsigned int v;

#ifdef DEBUG
	DBG_FUNC();
	hal_mmu_check();
#endif
	v = 0x0040174A; // modified
	writel(v, NFC_FLASH_CONFIG2_REG);

	writel(0xFFFF0000, UNLOCK_BLK_ADD0_REG);
	writel(0xFFFF0000, UNLOCK_BLK_ADD1_REG);
	writel(0xFFFF0000, UNLOCK_BLK_ADD2_REG);
	writel(0xFFFF0000, UNLOCK_BLK_ADD3_REG);

	v = NFC_WR_PROT_CS0 | NFC_WR_PROT_BLS_UNLOCK | NFC_WR_PROT_WPC;
	writel(v, NFC_WR_PROT_REG);

	writel(0, NFC_IPC_REG);
#if 0
	/* PBC setup */
	//Enable UART transceivers also reset the Ethernet/external UART
	temp = readw(PBC_BASE + PBC_BCTRL1);

	writew(0x8023, PBC_BASE + PBC_BCTRL1);

	for (i = 0; i < 100000; i++) {
	}

	// clear the reset, toggle the LEDs
	writew(0xDF, PBC_BASE + PBC_BCTRL1_CLR);

	for (i = 0; i < 100000; i++) {
	}

	dummy = readb(0xB4000008);
	dummy = readb(0xB4000007);
	dummy = readb(0xB4000008);
	dummy = readb(0xB4000007);
#endif

#if 0
	/* Reset interrupt status reg */
	writew(0x1F, PBC_INT_REST);
	writew(0x00, PBC_INT_REST);
	writew(0xFFFF, PBC_INT_MASK);
#endif
	// UART1
	//RXD
	writel(0x0, IOMUXC_BASE_ADDR + 0x15C);
	writel(0x4, IOMUXC_BASE_ADDR + 0x604);
	writel(0x1C5, IOMUXC_BASE_ADDR + 0x3BC);

	//TXD
	writel(0x0, IOMUXC_BASE_ADDR + 0x160);
	writel(0x1C5, IOMUXC_BASE_ADDR + 0x3C0);

	//RTS
	writel(0x0, IOMUXC_BASE_ADDR + 0x164);
	writel(0x4, IOMUXC_BASE_ADDR + 0x600);
	writel(0x1C4, IOMUXC_BASE_ADDR + 0x3C4);

	//CTS
	writel(0x0, IOMUXC_BASE_ADDR + 0x168);
	writel(0x1C4, IOMUXC_BASE_ADDR + 0x3C8);
}

#if 0
static void configure_gpio(cyg_uint32 port, cyg_uint32 pin,
			   cyg_uint32 io_select, cyg_uint32 dir)
{
	cyg_uint32 tmp, rnum, roffset, cfg_val;

	if ((io_select & 0x200) == 0x200) {
		rnum = (io_select >> 12) & 0xff;
		roffset = (io_select >> 10) & 0x3;
		cfg_val = (io_select & 0xff);
		tmp = iomux_sw_mux_ctrl_reg_array[port][rnum];
		tmp &= ~(0xff << (roffset * 8));
		tmp |= (cfg_val << (roffset * 8));
		iomux_sw_mux_ctrl_reg_array[port][rnum] = tmp;
	}
	if ((io_select & 0x100) == 0x100) {
		/* Configure the direction of GPIO */
		if (dir) {
			*data_dir_reg_ptr_array[port] |= (1 << pin);
		} else {
			*data_dir_reg_ptr_array[port] &= ~(1 << pin);
		}
	}
}

static void configure_pad(cyg_uint32 port, cyg_uint32 reg_index, cyg_uint32 val)
{
	iomux_sw_mux_ctrl_reg_array[port][reg_index] = val;
}
#endif

#include CYGHWR_MEMORY_LAYOUT_H

typedef void code_fun(void);

void board_program_new_stack(void *func)
{
	register CYG_ADDRESS stack_ptr asm("sp");
	register CYG_ADDRESS old_stack asm("r4");
	register code_fun *new_func asm("r0");
	old_stack = stack_ptr;
	stack_ptr = CYGMEM_REGION_ram + CYGMEM_REGION_ram_SIZE - sizeof(CYG_ADDRESS);
	new_func = (code_fun*)func;
	new_func();
	stack_ptr = old_stack;
}

#define SRC_SRSR 0x08

static void display_board_info(void)
{
	char *reset_cause = "UNKNOWN";
	CYG_WORD32 srsr;

	DBG_FUNC();
	diag_printf("\nBoard Type: Ka-Ro TX37\n");

	HAL_READ_UINT32(SRC_BASE_ADDR + SRC_SRSR, srsr);
	switch (srsr) {
	case (1 << 0):
		reset_cause = "POWER_ON RESET";
		break;
	case (1 << 2):
		reset_cause = "EXTERNAL RESET";
		break;
	case (1 << 3):
		reset_cause = "COLD RESET";
		break;
	case (1 << 4):
		reset_cause = "WATCHDOG RESET";
		break;
	case (1 << 5):
		reset_cause = "JTAG RESET";
		break;
	case (1 << 16):
		reset_cause = "SOFT RESET";
		break;
	}

	diag_printf("Last RESET cause: %s\n", reset_cause);
}

RedBoot_init(display_board_info, RedBoot_INIT_LAST);
