#ifndef CYGONCE_HAL_PLATFORM_SETUP_H
#define CYGONCE_HAL_PLATFORM_SETUP_H

//=============================================================================
//
//	hal_platform_setup.h
//
//	Platform specific support for HAL (assembly code)
//
//=============================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
// at http://sources.redhat.com/ecos/ecos-license/
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
//===========================================================================

#define REMOVE_THIS_CRAP
//#define BORKED
#define USE_DCD
//#define USE_LED
//#define MX51_3STACK

#include <pkgconf/system.h>			// System-wide configuration info
#include CYGBLD_HAL_VARIANT_H			// Variant specific configuration
#include CYGBLD_HAL_PLATFORM_H			// Platform specific configuration
#include <cyg/hal/hal_soc.h>			// Variant specific hardware definitions
#include <cyg/hal/hal_mmu.h>			// MMU definitions
#include <cyg/hal/karo_tx51.h>			// Platform specific hardware definitions
#include CYGHWR_MEMORY_LAYOUT_H

#if defined(CYG_HAL_STARTUP_ROM) || defined(CYG_HAL_STARTUP_ROMRAM)
#define PLATFORM_SETUP1 _platform_setup1
#define CYGHWR_HAL_ARM_HAS_MMU

#ifdef CYG_HAL_STARTUP_ROMRAM
#define CYGSEM_HAL_ROM_RESET_USES_JUMP
#endif

#define TX51_NAND_PAGE_SIZE		2048
#define TX51_NAND_BLKS_PER_PAGE		64

#ifndef MX51_3STACK
#define DEBUG_LED_BIT			10
#define LED_GPIO_BASE			GPIO4_BASE_ADDR
#define LED_MUX_OFFSET			0x1d0
#define LED_MUX_MODE			0x13
#else
#define DEBUG_LED_BIT			0
#define LED_GPIO_BASE			GPIO1_BASE_ADDR
#define LED_MUX_OFFSET			0x3ac
#define LED_MUX_MODE			0x11
#endif

#define LED_ON	LED_CTRL #1
#define LED_OFF	LED_CTRL #0

#ifndef CYGOPT_HAL_ARM_TX51_DEBUG
	.macro	LED_CTRL,val
	.endm
	.macro	LED_BLINK,val
	.endm
	.macro  DELAY,ms
	.endm
#else
#define CYGHWR_LED_MACRO	LED_BLINK #\x
	.macro	DELAY,ms
	ldr	r10, =\ms
111:
	subs	r10, r10, #1
	bmi	113f
	ldr	r9, =(3600 / 10)
112:
	subs	r9, r9, #1
	bne	112b
	b	111b
	.ltorg
113:
	.endm

	.macro	LED_CTRL,val
	// switch user LED (GPIO4_10) on STK5
	ldr	r10, =LED_GPIO_BASE
	// GPIO_DR
	mov	r9, \val
	cmp	r9, #0
	movne	r9, #(1 << DEBUG_LED_BIT)	@ LED ON
	moveq	r9, #0				@ LED OFF
	str	r9, [r10, #GPIO_DR]
	.endm

	.macro	LED_BLINK,val
	mov	r8, \val
211:
	subs	r8, r8, #1
	bmi	212f
	LED_CTRL #1
	DELAY	200
	LED_CTRL #0
	DELAY	300
	b	211b
212:
	DELAY	1000
	.endm
#endif

	.macro	LED_INIT
	// initialize GPIO4_10 (PAD CSI2_D13) for LED on STK5
	ldr	r10, =LED_GPIO_BASE
	// GPIO_GDIR
	ldr	r9, [r10, #GPIO_GDIR]
	orr	r9, r9, #(1 << DEBUG_LED_BIT)
	str	r9, [r10, #GPIO_GDIR]
	// iomux
	ldr	r10, =IOMUXC_BASE_ADDR
	mov	r9, #LED_MUX_MODE
	str	r9, [r10, #LED_MUX_OFFSET]
	// GPIO_DR
	mov	r9, #(1 << DEBUG_LED_BIT)	@ LED ON
	str	r9, [r10, #GPIO_DR]
	.endm

#define DCDGEN(type, addr, data)  .long	type, addr, data

#define PLATFORM_PREAMBLE flash_header

// This macro represents the initial startup code for the platform
	.macro	_platform_setup1
#ifndef BORKED
KARO_TX51_SETUP_START:
	mrs	r0, CPSR
	mov	r0, #0x1f
	orr	r0, r0, #128
	orr	r0, r0, #64
	msr	CPSR_xc, r0

	ldr	r1, =ROM_BASE_ADDR
	ldr	r11, [r1, #ROM_SI_REV_OFFSET]

	setup_sdram

	ldr	r0, =GPC_BASE_ADDR
	cmp	r11, #0x10	  // r11 contains the silicon rev
	ldrls	r1, =0x1FC00000
	ldrhi	r1, =0x1A800000
	str	r1, [r0, #4]

	// Explicitly disable L2 cache
	mrc	15, 0, r0, c1, c0, 1
	bic	r0, r0, #0x2
	mcr	15, 0, r0, c1, c0, 1

	// reconfigure L2 cache aux control reg
	mov	r0, #0xC0		// tag RAM
	add	r0, r0, #0x4		// data RAM
	orr	r0, r0, #(1 << 24)	// disable write allocate delay
	orr	r0, r0, #(1 << 23)	// disable write allocate combine
	orr	r0, r0, #(1 << 22)	// disable write allocate

	@ cc is still set from "cmp r11, #0x10" above
	orrls	r0, r0, #(1 << 25)	@ disable write combine for TO 2 and lower revs

	mcr	15, 1, r0, c9, c0, 2

init_aips_start:
	init_aips
	LED_INIT
init_m4if_start:
	init_m4if

#ifdef CYG_HAL_STARTUP_ROMRAM     /* enable running from RAM */
	LED_BLINK #1
#endif /* CYG_HAL_STARTUP_ROMRAM */
init_clock_start:
	init_clock

Normal_Boot_Continue:
/*
 * Note:
 *	IOMUX/PBC setup is done in C function plf_hardware_init() for simplicity
 */
STACK_Setup:
	@ Set up a stack [for calling C code]
	ldr	r1, =__startup_stack
	ldr	r2, =RAM_BANK0_BASE
	orr	sp, r1, r2

	@ Create MMU tables
	bl	hal_mmu_init
	LED_BLINK #2

	/* Workaround for arm erratum #709718 */
	@ Setup PRRR so device is always mapped to non-shared
	mrc	MMU_CP, 0, r1, c10, c2, 0 // Read Primary Region Remap Register
	bic	r1, #(3 << 16)
	mcr	MMU_CP, 0, r1, c10, c2, 0 // Write Primary Region Remap Register

	@ Enable MMU
	ldr	r2, =10f
	mrc	MMU_CP, 0, r1, MMU_Control, c0
	orr	r1, r1, #7			@ enable MMU bit
	orr	r1, r1, #0x800			@ enable z bit
	orr	r1, r1, #(1 << 28)		@ Enable TEX remap, workaround for L1 cache issue
	mcr	MMU_CP, 0, r1, MMU_Control, c0

	/* Workaround for arm errata #621766 */
	mrc	MMU_CP, 0, r1, MMU_Control, c0, 1
	orr	r1, r1, #(1 << 5)		@ enable L1NEON bit
	mcr	MMU_CP, 0, r1, MMU_Control, c0, 1

	mov	pc, r2				@ Change address spaces
	.align	5
10:
	LED_BLINK #3
#endif // BORKED
	.endm	@ _platform_setup1

	/* AIPS setup - Only setup MPROTx registers. The PACR default values are good.*/
	.macro	init_aips
	/*
	* Set all MPROTx to be non-bufferable, trusted for R/W,
	* not forced to user-mode.
	*/
	ldr	r0, =AIPS1_CTRL_BASE_ADDR
	ldr	r1, AIPS1_PARAM
	str	r1, [r0, #0x00]
	str	r1, [r0, #0x04]
	ldr	r0, =AIPS2_CTRL_BASE_ADDR
	str	r1, [r0, #0x00]
	str	r1, [r0, #0x04]
	.endm	/* init_aips */

	.macro	WDOG_RESET
	ldr	r0, =WDOG_BASE_ADDR
	mov	r1, #0
1:
	strh	r1, [r0]
	b	1b
	.endm

	.macro	init_clock
	ldr	r0, =CCM_BASE_ADDR
	ldr	r1, [r0, #CLKCTL_CCR]
	tst	r1, #(1 << 12)
	bne	osc_ok

	orr	r1, r1, #(1 << 12)
	str	r1, [r0, #CLKCTL_CCR]

	ldr	r1, [r0, #CLKCTL_CCSR]
	bic	r1, #(1 << 9)	/* switch lp_apm to OSC */
	str	r1, [r0, #CLKCTL_CCSR]
osc_ok:
	/* Gate off clocks to the peripherals first */
	ldr	r1, =0x3FFFFFFF
	str	r1, [r0, #CLKCTL_CCGR0]
	ldr	r1, =0x0
	str	r1, [r0, #CLKCTL_CCGR1]
	str	r1, [r0, #CLKCTL_CCGR2]
	str	r1, [r0, #CLKCTL_CCGR3]

	ldr	r1, =0x00030000
	str	r1, [r0, #CLKCTL_CCGR4]
	ldr	r1, =0x00FFF030
	str	r1, [r0, #CLKCTL_CCGR5]
	ldr	r1, =0x00000300
	str	r1, [r0, #CLKCTL_CCGR6]

	/* Disable IPU and HSC dividers */
	mov	r1, #0x60000
	str	r1, [r0, #CLKCTL_CCDR]

	/* Make sure to switch the DDR away from PLL 1 */
	ldr	r1, CCM_CBCDR_VAL1
	str	r1, [r0, #CLKCTL_CBCDR]
	/* make sure divider effective */
1:
	ldr	r1, [r0, #CLKCTL_CDHIPR]
	cmp	r1, #0x0
	bne	1b

	/* Switch ARM to step clock */
	ldr	r1, [r0, #CLKCTL_CCSR]
	mov	r1, #0x4
	str	r1, [r0, #CLKCTL_CCSR]

	setup_pll PLL1, 800
	setup_pll PLL3, 665

	/* Switch peripheral to PLL 3 */
	ldr	r1, CCM_CBCMR_VAL1
	str	r1, [r0, #CLKCTL_CBCMR]

	ldr	r1, CCM_CBCDR_VAL2
	str	r1, [r0, #CLKCTL_CBCDR]

	setup_pll PLL2, 665

	/* Switch peripheral to PLL 2 */
	ldr	r1, CCM_CBCDR_VAL1
	str	r1, [r0, #CLKCTL_CBCDR]
	ldr	r1, CCM_CBCMR_VAL2
	str	r1, [r0, #CLKCTL_CBCMR]

	setup_pll PLL3, 216

	/* Set the platform clock dividers */
	ldr	r2, =PLATFORM_BASE_ADDR
	ldr	r1, PLATFORM_CLOCK_DIV
	str	r1, [r2, #PLATFORM_ICGC]

        /* Run TO 3.0 at Full speed, for other TO's wait till we increase VDDGP */
	cmp	r11, #0x10
	movls	r1, #1
	movhi	r1, #0
	str	r1, [r0, #CLKCTL_CACRR]

	/* Switch ARM back to PLL 1. */
	mov	r1, #0
	str	r1, [r0, #CLKCTL_CCSR]

	/* setup the rest */
	/* Use lp_apm (24MHz) source for perclk */
	ldr	r1, CCM_CBCMR_VAL2
	str	r1, [r0, #CLKCTL_CBCMR]
	@ ddr clock from PLL 1, all perclk dividers are 1 since using 24MHz
	ldr	r1, CCM_CBCDR_VAL3

	str	r1, [r0, #CLKCTL_CBCDR]

	/* Restore the default values in the Gate registers */
	ldr	r1, =0xFFFFFFFF
	str	r1, [r0, #CLKCTL_CCGR0]
	str	r1, [r0, #CLKCTL_CCGR1]
	str	r1, [r0, #CLKCTL_CCGR2]
	str	r1, [r0, #CLKCTL_CCGR3]
	str	r1, [r0, #CLKCTL_CCGR4]
	str	r1, [r0, #CLKCTL_CCGR5]
	str	r1, [r0, #CLKCTL_CCGR6]

	/* Use PLL 2 for UART's, get 66.5MHz from it */
	ldr	r1, CCM_VAL_0xA5A2A020
	str	r1, [r0, #CLKCTL_CSCMR1]
	ldr	r1, CCM_VAL_0x00C30321
	str	r1, [r0, #CLKCTL_CSCDR1]

	/* make sure divider effective */
1:
	ldr	r1, [r0, #CLKCTL_CDHIPR]
	cmp	r1, #0x0
	bne	1b

	mov	r1, #0x00000
	str	r1, [r0, #CLKCTL_CCDR]

	@ for cko - for ARM div by 8
	mov	r1, #0x000A0000
	orr	r1, r1, #0x00000F0
	str	r1, [r0, #CLKCTL_CCOSR]

	ldr	r1, [r0, #CLKCTL_CCR]
	bic	r1, #(1 << 8)		/* switch off FPM */
	str	r1, [r0, #CLKCTL_CCR]
end_clk_init:
	.endm	@ init_clock

	.macro	setup_pll pll_nr, mhz
	ldr	r2, BASE_ADDR_\pll_nr
	ldr	r1, PLL_VAL_0x1232
	str	r1, [r2, #PLL_DP_CTL]		@ Set DPLL ON (set UPEN bit); BRMO=1
	mov	r1, #0x2
	str	r1, [r2, #PLL_DP_CONFIG]	@ Enable auto-restart AREN bit

	ldr	r1, W_DP_OP_\mhz
	str	r1, [r2, #PLL_DP_OP]
	str	r1, [r2, #PLL_DP_HFS_OP]

	ldr	r1, W_DP_MFD_\mhz
	str	r1, [r2, #PLL_DP_MFD]
	str	r1, [r2, #PLL_DP_HFS_MFD]

	ldr	r1, W_DP_MFN_\mhz
	str	r1, [r2, #PLL_DP_MFN]
	str	r1, [r2, #PLL_DP_HFS_MFN]

	mov	r1, #0x3
	str	r1, [r2, #PLL_DP_CONFIG]	@ Assert LDREQ

	@ Now restart PLL
	ldr	r1, PLL_VAL_0x1232
	str	r1, [r2, #PLL_DP_CTL]
101:
	ldr	r1, [r2, #PLL_DP_CTL]
	ands	r1, r1, #0x1
	beq	101b
	.endm

	/* M3IF setup */
	.macro	init_m4if
	ldr	r1, =M4IF_BASE_ADDR
	ldr	r0, M4IF_M4IF4_VAL
	str	r0, [r1, #M4IF_MIF4]

	/* Configure M4IF registers, VPU and IPU given higher priority (=0x4) */
	ldr	r0, M4IF_FBPM0_VAL
	str	r0, [r1, #M4IF_FBPM0]
	.endm	/* init_m4if */

	.macro	setup_sdram
        cmp	r11, #0x10    // r11 contains the silicon rev
        bls	skip_setup
#if 0
        /* Decrease the DRAM SDCLK to HIGH Drive strength */
        ldr	r0, =IOMUXC_BASE_ADDR
        ldr	r1, =0x000000e5
        str	r1, [r0, #0x4b8]
        /* Change the delay line configuration */
        ldr	r0, =ESDCTL_BASE_ADDR
        ldr	r1, =0x00f49400
        str	r1, [r0, #ESDCTL_ESDCDLY1]
        ldr	r1, =0x00f49a00
        str	r1, [r0, #ESDCTL_ESDCDLY2]
        ldr	r1, =0x00f49100
        str	r1, [r0, #ESDCTL_ESDCDLY3]
        ldr	r1, =0x00f48900
        str	r1, [r0, #ESDCTL_ESDCDLY4]
        ldr	r1, =0x00f49400
        str	r1, [r0, #ESDCTL_ESDCDLY5]
#endif
skip_setup:
	.endm
#else // defined(CYG_HAL_STARTUP_ROM) || defined(CYG_HAL_STARTUP_ROMRAM)
#define PLATFORM_SETUP1
#endif

#define PLATFORM_VECTORS	 _platform_vectors
	.macro	_platform_vectors
	.globl	_KARO_MAGIC
_KARO_MAGIC:
	.ascii	"KARO_CE6"
	.globl	_KARO_STRUCT_SIZE
_KARO_STRUCT_SIZE:
	.word	0	// reserve space structure length

	.globl	_KARO_CECFG_START
_KARO_CECFG_START:
	.rept	1024/4
	.word	0	// reserve space for CE configuration
	.endr

	.globl	_KARO_CECFG_END
_KARO_CECFG_END:
	.endm

	.align	5
	.ascii	"KARO TX51 " __DATE__ " " __TIME__
	.align

/* SDRAM timing setup */
#define RALAT		1
#define LHD		0

#define RA_BITS		2	/* row addr bits - 11 */
#define CA_BITS		2	/* 0-2: col addr bits - 8 3: rsrvd */
#define DSIZ		2	/* 0: D[31..16] 1: D[15..D0] 2: D[31..0] 3: rsrvd */
#define SREFR		3	/* 0: disabled 1-5: 2^n rows/clock *: rsrvd */
#define SRT		0	/* 0: disabled *: 1: self refr. ... */
#define PWDT		0	/* 0: disabled 1: precharge pwdn
				   2: pwdn after 64 clocks 3: pwdn after 128 clocks */
#define ESDCTL0_VAL	(0x80000000 | (SREFR << 28) | (RA_BITS << 24) | (CA_BITS << 20) | \
			 (DSIZ << 16) | (SRT << 14) | (PWDT << 12))

#define tRFC		17	/* clks - 1 (0..15) */ // 17
#define tXSR		19	/* clks - 1 (0..15) */ // 19
#define tXP		0	/* clks - 1 (0..7)  */ // N/A
#define tWTR		0	/* clks - 1 (0..1)  */ // N/A
#define tRP		1	/* clks - 2 (0..3)  */ // 1
#define tMRD		1	/* clks - 1 (0..3)  */ // 1
#define tWR		0	/* clks - 2 (0..1)  */ // 0
#define tRAS		5	/* clks - 1 (0..15) */ // 5
#define tRRD		1	/* clks - 1 (0..3)  */ // 1
#define tRCD		2	/* clks - 1 (0..7) */ // 2
#define tRC		8	/* 0: 20 *: clks - 1 (0..15) */ // 8

#define ESDCFG0_VAL	((((tRFC) - 10) << 28) | ((tXSR) << 24) | ((tXP) << 21) | \
			((tWTR) << 20) | ((tRP) << 18) | ((tMRD) << 16) | \
			((tRAS) << 12) | ((tRRD) << 10) | ((tWR) << 7) | \
			((tRCD) << 4) | ((tRC) << 0))

#define ESDMISC_RALAT(n)	(((n) & 0x3) << 7)
#define ESDMISC_DDR2_EN(n)	(((n) & 0x1) << 4)
#define ESDMISC_DDR_EN(n)	(((n) & 0x1) << 3)
#define ESDMISC_AP(n)		(((n) & 0xf) << 16)
#define ESDMISC_VAL		(ESDMISC_AP(10) | ESDMISC_RALAT(RALAT) | \
				(LHD << 5) | ESDMISC_DDR2_EN(0) | ESDMISC_DDR_EN(0))

	.macro	flash_header
	b	reset_vector
	.org	0x400
app_start_addr:
	.long reset_vector
app_code_barker:
	.long	0xB1
app_code_csf:
	.long	0 // 0x97f40000 - 0x1000
dcd_ptr_ptr:
	.long	dcd_ptr
super_root_key:
	.long	0 // hab_super_root_key
dcd_ptr:
	.long	dcd_data
app_dest_ptr:
#ifndef RAM_BANK1_SIZE
	.long	RAM_BANK0_BASE + RAM_BANK0_SIZE - REDBOOT_OFFSET
#else
	.long	RAM_BANK1_BASE + RAM_BANK1_SIZE - REDBOOT_OFFSET
#endif
dcd_data:
	.long	0xB17219E9   // Fixed. can't change.
dcd_len:
	.long	dcd_end - dcd_start
dcd_start:
	DCDGEN(4, ESDCTL_BASE_ADDR + ESDCTL_ESDCTL0, 0x80000000)
	DCDGEN(4, ESDCTL_BASE_ADDR + ESDCTL_ESDSCR, 0x04008008)
	DCDGEN(4, ESDCTL_BASE_ADDR + ESDCTL_ESDSCR, 0x00008010)
	DCDGEN(4, ESDCTL_BASE_ADDR + ESDCTL_ESDSCR, 0x00008010)
	DCDGEN(4, ESDCTL_BASE_ADDR + ESDCTL_ESDSCR, 0x00338018)
	DCDGEN(4, ESDCTL_BASE_ADDR + ESDCTL_ESDCTL0, ESDCTL0_VAL)
	DCDGEN(4, ESDCTL_BASE_ADDR + ESDCTL_ESDCFG0, ESDCFG0_VAL)
	DCDGEN(4, ESDCTL_BASE_ADDR + 0x34, 0x00020000 | ((RALAT & 0x3) << 29))
	DCDGEN(4, ESDCTL_BASE_ADDR + ESDCTL_ESDMISC, ESDMISC_VAL)
	DCDGEN(4, ESDCTL_BASE_ADDR + ESDCTL_ESDSCR, 0x00000000)
dcd_end:
image_len:
	.long	REDBOOT_IMAGE_SIZE
	.endm

SRC_BASE_ADDR_W:	.long	SRC_BASE_ADDR
WDOG_BASE_ADDR_W:	.long	WDOG_BASE_ADDR
AIPS1_PARAM:		.word	0x77777777
M4IF_M4IF4_VAL:		.word	0x00000203
M4IF_FIDBP_VAL:		.word	0x00000a01
M4IF_FBPM0_VAL:		.word	0x00000404
MXC_REDBOOT_ROM_START:	.long	SDRAM_BASE_ADDR + SDRAM_SIZE - REDBOOT_OFFSET
CCM_CBCDR_VAL1:		.word	0x19239145
CCM_CBCDR_VAL2:		.word	0x13239145
CCM_CBCDR_VAL3:		.word	0x61E35100
CCM_CBCMR_VAL1:		.word	0x000010C0
CCM_CBCMR_VAL2:		.word	0x000020C0
BASE_ADDR_PLL1:		.long	PLL1_BASE_ADDR
BASE_ADDR_PLL2:		.long	PLL2_BASE_ADDR
BASE_ADDR_PLL3:		.long	PLL3_BASE_ADDR
//PLL_VAL_0x222:		.word	0x222
//PLL_VAL_0x232:		.word	0x232
PLL_VAL_0x1232:		.word	0x1232
W_DP_OP_800:		.word	DP_OP_800
W_DP_MFD_800:		.word	DP_MFD_800
W_DP_MFN_800:		.word	DP_MFN_800
W_DP_OP_700:		.word	DP_OP_700
W_DP_MFD_700:		.word	DP_MFD_700
W_DP_MFN_700:		.word	DP_MFN_700
W_DP_OP_400:		.word	DP_OP_400
W_DP_MFD_400:		.word	DP_MFD_400
W_DP_MFN_400:		.word	DP_MFN_400
W_DP_OP_532:		.word	DP_OP_532
W_DP_MFD_532:		.word	DP_MFD_532
W_DP_MFN_532:		.word	DP_MFN_532
W_DP_OP_665:		.word	DP_OP_665
W_DP_MFD_665:		.word	DP_MFD_665
W_DP_MFN_665:		.word	DP_MFN_665
W_DP_OP_216:		.word	DP_OP_216
W_DP_MFD_216:		.word	DP_MFD_216
W_DP_MFN_216:		.word	DP_MFN_216
PLATFORM_CLOCK_DIV:	.word	0x00000124

#ifdef REMOVE_THIS_CRAP
CCM_VAL_0xA5A2A020:	.word	0xA5A2A020
CCM_VAL_0x00C30321:	.word	0x00C30321
#endif

/*----------------------------------------------------------------------*/
/* end of hal_platform_setup.h						*/
#endif /* CYGONCE_HAL_PLATFORM_SETUP_H */
