#ifndef CYGONCE_PLF_IO_H
#define CYGONCE_PLF_IO_H

//=============================================================================
//
//      plf_io.h
//
//      Platform specific IO support
//
//=============================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
// at http://sources.redhat.com/ecos/ecos-license/
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
//=============================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):    usteinkohl
// Contributors: usteinkohl
// Date:         16th January 2003
// Purpose:      Ka-Ro Triton  IO support macros
// Description: 
// Usage:        #include <cyg/hal/plf_io.h>
//
//####DESCRIPTIONEND####
//
//=============================================================================



unsigned long _fu_phys_address(unsigned long);



#define CYGARC_PHYSICAL_ADDRESS(_x_) 	(_fu_phys_address((unsigned long)_x_))


#ifdef CYGHWR_REDBOOT_LINUX_ATAG_MEM
#error CYGHWR_REDBOOT_LINUX_ATAG_MEM already defined
#endif
#define CYGHWR_REDBOOT_LINUX_ATAG_MEM(_p_)                                                      \
    CYG_MACRO_START                                                                             \
    /* Next ATAG_MEM. */                                                                        \
    _p_->hdr.size = (sizeof(struct tag_mem32) + sizeof(struct tag_header))/sizeof(long);        \
    _p_->hdr.tag = ATAG_MEM;                                                                    \
    /* Round up so there's only one bit set in the memory size.                                 \
     * Don't double it if it's already a power of two, though.                                  \
     */                                                                                         \
    _p_->u.mem.size  = CYGMEM_REGION_ram_SIZE;                       					          \
    _p_->u.mem.start = CYGMEM_REGION_ram;                              \
    CYG_MACRO_END
					


//-----------------------------------------------------------------------------

//  IDE interface


#if (TRITON_STK==2)								
	#define HAL_HAG_IDE_SKT1_CMD          (0x30000000)
	#define HAL_HAG_IDE_SKT1_CTL          (0x30400000)
	#define HAL_HAG_IDE_SKT2_CMD          (0x30000000)
	#define HAL_HAG_IDE_SKT2_CTL          (0x30400000)
#elif (TRITON_STK==1)
	#define HAL_HAG_IDE_SKT1_CMD          (0x30000000)
	#define HAL_HAG_IDE_SKT1_CTL          (0x30400000)
	#define HAL_HAG_IDE_SKT2_CMD          (0x30000000)
	#define HAL_HAG_IDE_SKT2_CTL          (0x30400000)
#else
	#error: unknown starter kit type
#endif






#define HAL_IDE_NUM_CONTROLLERS 1

// Initialize the IDE controller(s).
externC void cyg_hal_plf_ide_init(void);
#define HAL_IDE_INIT() cyg_hal_plf_ide_init()



#define __CMD_ADDR(__n) ((__n) ? HAL_HAG_IDE_SKT2_CMD : HAL_HAG_IDE_SKT1_CMD)
#define __CTL_ADDR(__n) ((__n) ? HAL_HAG_IDE_SKT2_CTL : HAL_HAG_IDE_SKT1_CTL)

#define HAL_IDE_READ_UINT8( __ctlr, __regno  , __val )  \
    HAL_READ_UINT8(__CMD_ADDR(__ctlr) + (__regno), (__val))
#define HAL_IDE_READ_UINT16( __ctlr, __regno, __val )  \
    HAL_READ_UINT16(__CMD_ADDR(__ctlr) + (__regno), (__val))
#define HAL_IDE_READ_ALTSTATUS( __ctlr, __val )  \
    HAL_READ_UINT16(__CTL_ADDR(__ctlr) + 2, (__val))

#define HAL_IDE_WRITE_UINT8( __ctlr, __regno, __val )  \
    HAL_WRITE_UINT8(__CMD_ADDR(__ctlr) + (__regno), (__val))
#define HAL_IDE_WRITE_UINT16( __ctlr, __regno, __val )  \
    HAL_WRITE_UINT16(__CMD_ADDR(__ctlr) + (__regno), (__val))
#define HAL_IDE_WRITE_CONTROL( __ctlr, __val )  \
    HAL_WRITE_UINT16(__CTL_ADDR(__ctlr) + 2, (__val))



// end of plf_io.h
#endif // CYGONCE_PLF_IO_H
